--- encoder/encoder.c
+++ encoder/encoder.c
@@ -332,7 +332,6 @@
     }
 
     h->param.i_threads = x264_clip3( h->param.i_threads, 1, X264_SLICE_MAX );
-    h->param.i_threads = X264_MIN( h->param.i_threads, (h->param.i_height + 15) / 16 );
 #ifndef HAVE_PTHREAD
     if( h->param.i_threads > 1 )
     {
@@ -1114,8 +1113,8 @@
                 bs_init( &t->out.bs, t->out.p_bitstream, i_bs_size );
                 t->i_thread_num = i;
             }
-            t->sh.i_first_mb = (i    * h->sps->i_mb_height / h->param.i_threads) * h->sps->i_mb_width;
-            t->sh.i_last_mb = ((i+1) * h->sps->i_mb_height / h->param.i_threads) * h->sps->i_mb_width;
+            t->sh.i_first_mb = i    * h->sps->i_mb_height * h->sps->i_mb_width / h->param.i_threads;
+            t->sh.i_last_mb = (i+1) * h->sps->i_mb_height * h->sps->i_mb_width / h->param.i_threads;
             t->out.i_nal = i_nal + i;
         }
         x264_ratecontrol_threads_start( h );
--- common/common.h
+++ common/common.h
@@ -88,7 +88,7 @@
 }
 
 #define X264_BFRAME_MAX 16
-#define X264_SLICE_MAX 4
+#define X264_SLICE_MAX 8192
 #define X264_NAL_MAX (4 + X264_SLICE_MAX)
 
 /****************************************************************************
